# istreambuf_iterator Class Template Reference

Inheritance diagram for istreambuf_iterator:

List of all members.

### template<typename _CharT, typename _Traits>
class std::istreambuf_iterator< _CharT, _Traits >

## Public Types

- typedef _CharT char_type
- typedef _Traits::off_type difference_type
- typedef _Traits::int_type int_type
- typedef basic_istream< _CharT,
  _Traits > istream_type
- typedef input_iterator_tag iterator_category
- typedef _CharT * pointer
- typedef _CharT & reference
- typedef basic_streambuf< _CharT,
  _Traits > streambuf_type
- typedef _Traits traits_type
- typedef _CharT value_type

## Public Member Functions

- bool equal (const istreambuf_iterator &__b) const
- istreambuf_iterator (streambuf_type *__s) throw ()
- istreambuf_iterator (istream_type &__s) throw ()
- istreambuf_iterator () throw ()
- char_type operator * () const
- istreambuf_iterator operator++ (int)
- istreambuf_iterator & operator++ ()

## Member Typedef Documentation

typedef _CharT char_type

| Public typedefs. Definition at line 59 of file streambuf_iterator.h.

typedef _Traits::off_type difference_type `[inherited]`

| Distance between iterators is represented as this type. Definition at line 113 of file stl_iterator_base_types.h.

typedef input_iterator_tag iterator_category `[inherited]`

| One of the tag types. Definition at line 109 of file stl_iterator_base_types.h.

typedef _CharT * pointer `[inherited]`

| This type represents a pointer-to-value_type. Definition at line 115 of file stl_iterator_base_types.h.

typedef _CharT & reference `[inherited]`

| This type represents a reference-to-value_type. Definition at line 117 of file stl_iterator_base_types.h.

typedef _CharT value_type `[inherited]`

| The type "pointed to" by the iterator. Definition at line 111 of file stl_iterator_base_types.h.

## Constructor & Destructor Documentation

istreambuf_iterator | ( |  | ) | throw ()`[inline]`

| Construct end of input stream iterator. Definition at line 79 of file streambuf_iterator.h.

istreambuf_iterator | ( | istream_type & | __s | ) | throw ()`[inline]`

| Construct start of input stream iterator. Definition at line 83 of file streambuf_iterator.h.

istreambuf_iterator | ( | streambuf_type * | __s | ) | throw ()`[inline]`

| Construct start of streambuf iterator. Definition at line 87 of file streambuf_iterator.h.

## Member Function Documentation

bool equal | ( | const istreambuf_iterator< _CharT, _Traits > & | __b | ) | const`[inline]`

| Return true both iterators are end or both are not end. Definition at line 143 of file streambuf_iterator.h. References istreambuf_iterator::_M_at_eof().

char_type operator * | ( |  | ) | const`[inline]`

| operator*() on an end of stream is undefined. Definition at line 94 of file streambuf_iterator.h.

istreambuf_iterator operator++ | ( | int |  | ) | `[inline]`

| Advance the iterator. Calls streambuf.sbumpc(). Definition at line 123 of file streambuf_iterator.h. References istreambuf_iterator::_M_c, and basic_streambuf::sbumpc().

istreambuf_iterator& operator++ | ( |  | ) | `[inline]`

| Advance the iterator. Calls streambuf.sbumpc(). Definition at line 108 of file streambuf_iterator.h. References basic_streambuf::sbumpc().

The documentation for this class was generated from the following file:

- streambuf_iterator.h